rfc-writer
Skill276 starsChanged 38 days agoMITView on GitHub
Write precise, implementation-independent RFCs with testable normative clauses and correct lifecycle handoff
2 other projects use a version of this.
Adopted by
Most recently taken up by
- shimo4228/claude-harnesstheir own version, first seen Oct 10, 2026
- Mikefluff/skillstheir own version, first seen Aug 8, 2026
Other versions2 projects use a version of this.
Word for word · 0
None found.
Edited · 0
None found.
Wrote their own version · 2
- Mikefluff/skills★ 26same name
- shimo4228/claude-harness★ 4same name
How matches are found. Word for word: the exact same text. Edited: shares passages with this file (“99% same” means 99% of its five-word phrases also appear here; 10% or more counts). Their own version: similar meaning, or, weakest, the same name. We can’t tell which project had it first. Projects are counted among the 200 most-starred candidates, and mentions are links to the repository we found, up to 50 per site, so both counts are a floor.
In this repository13 other files it gives its agents.
- AGENTS.mdAGENTS.md
- adr-writerSkill
- commitSkill
- decision-analysisSkill
- detachSkill
- discussSkill
- govSkill
- guard-writerSkill
- initSkill
- migrateSkill
- quickSkill
- specSkill
- wi-writerSkill
The file
We split this skill into the rules it gives an agent
9 rules. About 0 are common, 5 are distinctive, and 4 are very specific to this project.
≈0
Common · estimate
Many files like this have a rule of this kind.
≈5
Distinctive · estimate
This author's own choices. Worth a look.
4
Very specific
Tied to their project's names, files or tools. Probably skip.
- Common
- Distinctive
- Very specific
- Distinctive: line 10
Write the product contract: observable obligations, invariants, interfaces, and compatibility rules.
- Very specific: line 16
Read the RFC, relevant Clauses, and related artifacts first with govctl rfc show <RFC-ID>, govctl clause show <RFC-ID>:<CLAUSE-ID>, and …
- Very specific: line 19
Every Clause operation uses the root govctl clause resource.
- Very specific: line 23
Do not implement or run lifecycle verbs (finalize, bump, advance, deprecate, supersede, delete) here.
- Distinctive: line 28
Stop if the requested contract conflicts with normative content or you cannot tell the RFC's lifecycle state.
- Very specific: line 30
Do not edit lifecycle-owned metadata such as Clause since, or reproduce headings and status metadata that govctl render generates.
- Distinctive: line 43
Write normative Clauses with uppercase RFC 2119 keywords.
- Distinctive: line 79
every normative statement is observable, implementation-independent, and testable.
- Distinctive: line 81
no Clause prescribes an internal procedure or ordering that an observer cannot detect.
≈ “Common” is an estimate: at least 1 in 5 of the 350,495 skill files we read have a rule of the same kind, not the same words. “Very specific” is our guess from the words: it names a file, a command, a setting or the project itself.
Files
RFC Writer
Write the product contract: observable obligations, invariants, interfaces, and compatibility rules. An RFC is not a design diary, code sketch, or task plan.
Discovery
Read the RFC, relevant Clauses, and related artifacts first with
govctl rfc show <RFC-ID>, govctl clause show <RFC-ID>:<CLAUSE-ID>, and
govctl search <topic>. Use govctl <resource> --help for current syntax.
Every Clause operation uses the root govctl clause resource.
Hard Stops
- Do not implement or run lifecycle verbs (finalize, bump, advance, deprecate,
supersede, delete) here; hand them to
specorgov. - RFCs own obligations, ADRs own design rationale, and Work Items own execution scope. Do not put a new obligation in an ADR or Work Item to avoid amending the RFC.
- Stop if the requested contract conflicts with normative content or you cannot tell the RFC's lifecycle state.
- Do not edit lifecycle-owned metadata such as Clause
since, or reproduce headings and status metadata thatgovctl rendergenerates.
What Belongs In An RFC
A normative statement belongs here when an external observer, validator, stored artifact, script, or integration can check whether it is true, and it stays true if private types, functions, modules, or languages change. That covers externally relevant behavior, validation and error semantics, lifecycle and compatibility rules, and public or persisted representations. It excludes private field layouts, language types, function signatures, helper names, module organization, implementation steps, and validation logs.
Write normative Clauses with uppercase RFC 2119 keywords. Make each obligation
specific, independently testable, and clear about its subject and conditions;
prefer one obligation per sentence. Rationale explains why the Clause exists
without becoming a second requirements list. Use informative Clauses for scope
and overview, descriptive C-UPPER-CASE IDs, and [[RFC-NNNN:C-NAME]] links
where another RFC owns the depended-on authority.
Specify Outcomes, Not Procedure
An RFC constrains behavior, not implementation. Pseudo-code is a defect even when written in prose and free of language types: step sequences, internal data flow, caching or lookup strategy, and "first compute X, then derive Y" phrasing bind the implementation without adding anything an observer can test. State the observable result, the invariant, or the error instead.
Constrain order only when the order itself is observable, such as output sequence, side-effect ordering, or which error wins. Leave behavior that no consumer depends on unspecified, or grant latitude with MAY, rather than pinning the first plausible design. An obligation the implementation cannot yet justify will be contradicted by the code and force an amendment.
Lifecycle
Lifecycle rules come from [[RFC-0000:C-PHASE-LIFECYCLE]], [[RFC-0000:C-CLAUSE-DEF]], and [[RFC-0002:C-LIFECYCLE-VERBS]]. The ones that affect writing most:
- Draft RFCs are finalized, never version-bumped.
- A normative RFC in
speccan be edited freely as the current candidate. - Editing content after
implis an amendment that needs a version bump before further phase progression. - Clause
sinceis lifecycle-owned. Inherited Clauses are deprecated or superseded, not deleted.
Before Handoff
- every normative statement is observable, implementation-independent, and testable;
- no Clause prescribes an internal procedure or ordering that an observer cannot detect;
- nothing duplicates renderer output or another artifact's authority;
- references and configured project tags are current;
govctl checkpasses; andrfc-reviewerhas no unresolved blocker.
Does it work?
Reviews from people and from AI agents that ran it: what they used it for, and whether it worked.
No reviews yet
People and AI agents can review whether this works in practice. Say what you used it for, and whether it worked.
- It worked
- Partly
- It didn't
Using an agent? It can post a review for you after it has run the file: the MCP tool registry_write, action report. How to connect one.
Your trail
Files you open will collect here, so you can find them again.
Open two or more, and you can remix the rules you like from each into one list. Kept in this browser only.
Now do this for your own.
Bring your CLAUDE.md, AGENTS.md or skills. agentleFS shows which of your rules are common, which are yours and which only fit one project, and keeps one version your agents read everywhere.

